//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
// Class to hold the x,y,z values of a geometric point
// Written by Kristi Potter June 2011
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
class Point {
    float _x, _y, _z; // coordinates of the point
    int _idx;         // index of the point
    float x() { return _x; }
    float y() { return _y; }
    float z() { return _z; }
    int idx() { return _idx; }
    void x(float x){ _x = x; }
    void y(float y){ _y = y; }
    void z(float z){ _z = z; }
    void idx(int i){ _idx = i; }
    Point(){ _x=0; _y=0; _z=0; _idx=-1; }
    Point(float x, float y, float z){ _x=x; _y=y; _z=z; }
    Point(float x, float y)         { _x=x; _y=y; _z=0.0f; }
    Point(Point copy){ _x=copy.x(); _y=copy.y(); _z=copy.z(); } 
    void printPoint(){ System.out.println("("+_x+", "+_y+", "+_z+")"); }
    void setZero(){ _x = 0.f; _y = 0.f; _z = 0.f; }

    // Distance between two points
    float distance (Point b) { return (float)Math.sqrt((_x-b.x())*(_x-b.x()) + 
						      (_y-b.y())*(_y-b.y()) +
						      (_z-b.z())*(_z-b.z())); }
}
